Loading...
Searching...
No Matches
Sip_content_length

## Data Structures

struct | sip_content_length_s
| Structure for Content-Length header. More...

## Macros

#define | sip_content_length(sip)
| Access a SIP Content-Length header structure sip_content_length_t from sip_t.
#define | SIP_CONTENT_LENGTH_INIT()
| Initializer for structure sip_content_length_t.
#define | SIPTAG_CONTENT_LENGTH(x)
| Tag list item for pointer to a Content-Length header structure sip_content_length_t.
#define | SIPTAG_CONTENT_LENGTH_REF(x)
| Tag list item for reference to a Content-Length header pointer.
#define | SIPTAG_CONTENT_LENGTH_STR(s)
| Tag list item for string with Content-Length header value.
#define | SIPTAG_CONTENT_LENGTH_STR_REF(x)
| Tag list item for reference to a Content-Length header string.

## Typedefs

typedef struct sip_content_length_s | sip_content_length_t
| @

## Functions

issize_t | sip_content_length_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Content-Length header.
issize_t | sip_content_length_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Content-Length header.
sip_content_length_t * | sip_content_length_init (sip_content_length_t x[1])
| Initialize a structure sip_content_length_t.
int | sip_is_content_length (sip_header_t const *header)
| Test if header object is instance of sip_content_length_t.
sip_content_length_t * | sip_content_length_dup (su_home_t *home, sip_content_length_t const *hdr))
| Duplicate a list of Content-Length header header structures sip_content_length_t.
sip_content_length_t * | sip_content_length_copy (su_home_t *home, sip_content_length_t const *hdr))
| Copy a list of Content-Length header header structures sip_content_length_t.
sip_content_length_t * | sip_content_length_make (su_home_t *home, char const *s))
| Make a Content-Length header structure sip_content_length_t.
sip_content_length_t * | sip_content_length_format (su_home_t *home, char const *fmt,...)))
| Make a Content-Length header from formatting result.
sip_content_length_t * | sip_content_length_create (su_home_t *home, uint32_t n)
| Create a Content-Length header object.

## Variables

msg_hclass_t | sip_content_length_class []
| Header class for Content-Length header.
tag_typedef_t | siptag_content_length
| Tag for Content-Length header object.
tag_typedef_t | siptag_content_length_str
| Tag for string with Content-Length header value.

## Detailed Description

## Macro Definition Documentation

## SIP_CONTENT_LENGTH_INIT

#define SIP_CONTENT_LENGTH_INIT | ( |  | ) |

Initializer for structure sip_content_length_t.

A static sip_content_length_t structure for Content-Length header must be initialized with the SIP_CONTENT_LENGTH_INIT() macro. For instance,

sip_content_length_t sip_content_length = SIP_CONTENT_LENGTH_INIT;
sip_content_length
#define sip_content_length(sip)
Access a SIP Content-Length header structure sip_content_length_t from sip_t.
Definition sip_protos.h:15839
sip_content_length_t
struct sip_content_length_s sip_content_length_t
@
Definition sip.h:154
SIP_CONTENT_LENGTH_INIT
#define SIP_CONTENT_LENGTH_INIT()
Initializer for structure sip_content_length_t.
Definition sip_protos.h:15856

## SIPTAG_CONTENT_LENGTH

#define SIPTAG_CONTENT_LENGTH | ( |  | x | ) |

Tag list item for pointer to a Content-Length header structure sip_content_length_t.

The SIPTAG_CONTENT_LENGTH() macro is used to include a tag item with a pointer to a sip_content_length_t structure in a tag list.

Parameters

  x | pointer to a sip_content_length_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_CONTENT_LENGTH_REF().

## SIPTAG_CONTENT_LENGTH_STR

#define SIPTAG_CONTENT_LENGTH_STR | ( |  | s | ) |

Tag list item for string with Content-Length header value.

The SIPTAG_CONTENT_LENGTH_STR() macro is used to include a tag item with a string containing value of a sip_content_length_t header in a tag list.

Parameters

  s | pointer to a string containing Content-Length header value, or NULL.

The string in SIPTAG_CONTENT_LENGTH_STR() can be converted to a sip_content_length_t header structure by giving the string s has second argument to function sip_content_length_make().

The corresponding tag taking reference parameter is SIPTAG_CONTENT_LENGTH_STR_REF().

## Typedef Documentation

## sip_content_length_t

typedef struct sip_content_length_s sip_content_length_t

@

The Content-Length header indicates the size of the message-body in decimal number of octets. Its syntax is defined in RFC 3261 as follows:

Content-Length = ( "Content-Length" / "l" ) HCOLON 1*DIGIT
DIGIT
#define DIGIT

The parsed Content-Length header is stored in sip_content_length_t structure.

The structure sip_content_length_t contains representation of SIP Content-Length header.

The sip_content_length_t is defined as follows:

typedef struct sip_content_length_s {
sip_common_t l_common[1]; // Common fragment info
sip_error_t *l_next; // Dummy link to next
uint32_t l_length; // Message body length in bytes
} sip_content_length_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_content_length_s
Structure for Content-Length header.
Definition sip.h:489
sip_content_length_s::l_next
sip_error_t * l_next
Link to next (dummy).
Definition sip.h:491
sip_content_length_s::l_length
uint32_t l_length
Length in bytes.
Definition sip.h:492
sip_content_length_s::l_common
sip_common_t l_common[1]
Common fragment info.
Definition sip.h:490
uint32_t
SU_U32_T uint32_t

## Function Documentation

## sip_content_length_copy()

sip_content_length_t * sip_content_length_copy | ( | su_home_t * | home,
|  | sip_content_length_t const * | hdr )

inline

Copy a list of Content-Length header header structures sip_content_length_t.

The function sip_content_length_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  content_length = sip_content_length_copy(home, sip->sip_content_length);
  sip_content_length_copy
  sip_content_length_t * sip_content_length_copy(su_home_t *home, sip_content_length_t const *hdr))
  Copy a list of Content-Length header header structures sip_content_length_t.
  Definition sip_protos.h:15986

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_content_length_create()

sip_content_length_t * sip_content_length_create | ( | su_home_t * | home,
|  | uint32_t | n )

Create a Content-Length header object.

Create a Content-Length header object.

Create a Content-Length header object with the value n. The memory for the header is allocated from the memory home home.

Parameters

  home | memory home
  n | payload size in bytes

Returns
  A pointer to newly created Content-Length header object when successful or NULL upon an error.

## sip_content_length_dup()

sip_content_length_t * sip_content_length_dup | ( | su_home_t * | home,
|  | sip_content_length_t const * | hdr )

inline

Duplicate a list of Content-Length header header structures sip_content_length_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_length = sip_content_length_dup(home, sip->sip_content_length);
  sip_content_length_dup
  sip_content_length_t * sip_content_length_dup(su_home_t *home, sip_content_length_t const *hdr))
  Duplicate a list of Content-Length header header structures sip_content_length_t.
  Definition sip_protos.h:15943

Returns
  A pointer to the newly duplicated sip_content_length_t header structure, or NULL upon an error.

## sip_content_length_format()

sip_content_length_t * sip_content_length_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-Length header from formatting result.

Make a new sip_content_length_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_content_length_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_content_length_init()

sip_content_length_t * sip_content_length_init | ( | sip_content_length_t | x[1] | ) |

inline

Initialize a structure sip_content_length_t.

An sip_content_length_t structure for Content-Length header can be initialized with the sip_content_length_init() function/macro. For instance,

sip_content_length_t sip_content_length;
sip_content_length_init(&sip_content_length);
sip_content_length_init
sip_content_length_t * sip_content_length_init(sip_content_length_t x[1])
Initialize a structure sip_content_length_t.
Definition sip_protos.h:15874

## sip_content_length_make()

sip_content_length_t * sip_content_length_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Content-Length header structure sip_content_length_t.

The function sip_content_length_make() makes a new sip_content_length_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_content_length_t header structure, or NULL upon an error.

## sip_is_content_length()

int sip_is_content_length | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_content_length_t.

Check if the header class is an instance of Content-Length header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header content_length
  0 | (false) otherwise

## Variable Documentation

## sip_content_length_class

msg_hclass_t sip_content_length_class[]

extern

Header class for Content-Length header.

The header class sip_content_length_class defines how a SIP Content-Length header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_content_length_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.